<template>
  <v-row>
    <v-col v-if="!isPublicServices" cols="12">
      <v-text-field
        id="pac-input"
        ref="address"
        v-model="locationData.address"
        :loading="loading"
        :rules="rules"
        :disabled="typeOperator"
        prepend-inner-icon="mdi-map-marker"
        label="Ubicación *"
        required
        outlined
        hide-details
        pb-3
      ></v-text-field>
    </v-col>
    <v-col cols="12">
      <div id="google-map"></div>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import Vue from 'vue'
import _ from 'lodash'

declare let google: any

export default Vue.extend({
  name: 'Map',
  components: {},
  props: {
    location: {
      type: Object,
      default: () => ({
        lat: null,
        lng: null,
        address: null,
        custom: null,
        street: null,
        num_ext: null,
        num_int: null,
        neighborhood: null,
        between_streets: null,
        references: null,
      }),
    },
    hasLocation: {
      type: Boolean,
      default: false,
    },
    typeOperator: {
      type: Boolean,
      default: false,
    },
    isPublicServices: {
      type: Boolean,
      default: false,
    },
    reports: {
      type: [Array],
      default: () => [],
    },
    showReportMarker: {
      type: [Object, Boolean],
      default: false,
    },
  },
  data: () => ({
    map: null as any,
    marker: null as any,
    wholeMarkers: [] as any,
    rules: [(v: any) => !!v || 'El campo es requerido'],
    pos: {
      lat: 0,
      lng: 0,
    },
    LatLng: null,
    loading: false,
  }),
  computed: {
    locationData: {
      get(): any {
        return this.location
      },
    },
  },
  watch: {
    reports(newValue) {
      if (newValue) {
        this.setPublicServicesMap()
      }
    },
    showReportMarker(newValue) {
      if (newValue) {
        const id = newValue.id
        google.maps.event.trigger(this.wholeMarkers[id], 'click')
      }
    },
  },
  mounted() {
    if (this.isPublicServices) {
      this.setPublicServicesMap()
    } else {
      this.setMap()
    }
  },
  methods: {
    /* eslint-disable camelcase */
    coordinates(event: any, from: any) {
      this.loading = true
      const self = this
      const geocoder = new google.maps.Geocoder()
      let location
      if (from === 'autocomplete') {
        self.locationData.lat = event.lat()
        self.locationData.lng = event.lng()
        location = event
      } else {
        self.locationData.lat = event.latLng.lat()
        self.locationData.lng = event.latLng.lng()
        location = event.latLng
        self.map.setCenter(location)
        self.marker.setPosition(location)
      }
      geocoder.geocode({ location }, (results: any) => {
        _.forEach(results, (element: any) => {
          if (element.types[0] === 'street_address') {
            if (from !== 'autocomplete') {
              self.locationData.address = element.formatted_address
            }
            _.forEach(element.address_components, function (el: any) {
              if (el.types.includes('route')) {
                self.locationData.street = el.long_name
              }
              if (el.types.includes('street_number')) {
                self.locationData.num_ext = parseInt(el.long_name)
              }
              if (
                el.types.includes('neighborhood') ||
                el.types.includes('sublocality')
              ) {
                self.locationData.neighborhood = el.long_name
              }
            })
          }
        })
        self.$emit('change', self.locationData)
        self.loading = false
      })
    },
    getCurrentPosition() {
      if (this.$route.path !== '/profile') {
        const self = this
        return new Promise((resolve) => {
          if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(
              function (position) {
                self.pos = {
                  lat: position.coords.latitude,
                  lng: position.coords.longitude,
                }
                resolve(self.pos)
              },
              function (err) {
                resolve(err)
              }
            )
          }
        })
      }
    },
    async setMap() {
      const self = this
      self.loading = true
      const element = document.getElementById('google-map')
      if (self.locationData.lat && self.locationData.lng) {
        self.LatLng = new google.maps.LatLng(
          self.locationData.lat,
          self.locationData.lng
        )
      } else {
        self.LatLng = new google.maps.LatLng(
          self.$store.state.setting.setting.location.lat,
          self.$store.state.setting.setting.location.lng
        )
      }
      const options = {
        zoom: parseInt(self.$store.state.setting.setting.location.zoom),
        center: self.LatLng,
      }
      self.map = new google.maps.Map(element, options)
      self.marker = new google.maps.Marker({
        position: self.LatLng,
        draggable: true,
        animation: google.maps.Animation.DROP,
        map: self.map,
      })
      self.marker.addListener('dragend', self.coordinates)
      google.maps.event.addListener(self.map, 'click', function (event: any) {
        self.coordinates(event, 'click')
      })
      const geocoder = new google.maps.Geocoder()
      const input = document.getElementById('pac-input')
      const autocomplete = new google.maps.places.Autocomplete(input)
      autocomplete.bindTo('bounds', self.map)
      autocomplete.addListener('place_changed', () => {
        self.loading = true
        const place = autocomplete.getPlace()
        let address = ''
        if (place.formatted_address) {
          address = place.formatted_address
          self.locationData.address = place.formatted_address
        } else {
          address = place.name
        }
        if (place && place.geometry && place.geometry.location) {
          self.map.setCenter(place.geometry.location)
          self.marker.setPosition(place.geometry.location)
          if (place.name) {
            self.locationData.place = place.name
          }
          self.coordinates(place.geometry.location, 'autocomplete')
        } else {
          geocoder.geocode({ address }, function (results: any, status: any) {
            if (status !== 'OK') {
              window.alert('Geocoder failed due to: ' + status)
              return
            }
            if (results && results.length > 0) {
              self.map.setCenter(results[0].geometry.location)
              self.marker.setPosition(results[0].geometry.location)
              self.coordinates(results[0].geometry.location, 'autocomplete')
            }
          })
        }
        self.loading = false
      })
      await this.getCurrentPosition()
      self.loading = false
    },
    setPublicServicesMap() {
      const self = this
      self.loading = true
      self.LatLng = new google.maps.LatLng(
        self.$store.state.setting.setting.location.lat,
        self.$store.state.setting.setting.location.lng
      )
      const element = document.getElementById('google-map')
      if (self.locationData.lat && self.location.lng) {
        self.LatLng = new google.maps.LatLng(
          self.locationData.lat,
          self.locationData.lng
        )
      }
      const options = {
        zoom: parseInt(self.$store.state.setting.setting.location.zoom),
        center: self.LatLng,
      }
      self.map = new google.maps.Map(element, options)
      self.wholeMarkers = []
      self.reports.forEach((element: any) => {
        const mark = new google.maps.Marker({
          position: { lat: element.location.lat, lng: element.location.lng },
          animation: google.maps.Animation.DROP,
          map: self.map,
          title: element.title,
        })
        const infowindow = new google.maps.InfoWindow({
          // eslint-disable-next-line vue/no-parsing-error
          content: `<div class="infowindow"><h4>Información del Reporte</h4><br>
          <span class="font-weight-bold">Servicio:</span> ${
            element.subcategory.name ? element.subcategory.name : '---'
          }<br>
          <span class="font-weight-bold">Fecha de creación:</span> ${
            element.created ? element.created.split('T')[0] : '---'
          }<br>
          <span class="font-weight-bold">Creado por:</span> ${
            element.owner ? element.owner.first_name : '---'
          }
            ${element.owner ? element.owner.last_name : '---'}<br>
          <span class="font-weight-bold">Email:</span> ${
            element.owner ? element.owner.email : '---'
          }<br>
          <br></div>
          `,
        })
        mark.addListener('click', () => {
          infowindow.open(self.map, mark)
        })
        self.wholeMarkers.push(mark)
      })
      self.loading = false
    },
  },
})
</script>

<style scoped>
#google-map {
  width: 100%;
  height: 400px;
}
</style>
